Index: LMDZ5/branches/testing/libf/phylmd/physiq.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/physiq.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/physiq.F90	(revision 2258)
@@ -4,5 +4,5 @@
 SUBROUTINE physiq (nlon,nlev, &
      debut,lafin,jD_cur, jH_cur,pdtphys, &
-     paprs,pplay,pphi,pphis,presnivs,clesphy0, &
+     paprs,pplay,pphi,pphis,presnivs, &
      u,v,t,qx, &
      flxmass_w, &
@@ -283,7 +283,7 @@
   !$OMP THREADPRIVATE(ok_hf)
 
-  INTEGER        longcles
-  PARAMETER    ( longcles = 20 )
-  REAL clesphy0( longcles      )
+  INTEGER,PARAMETER :: longcles=20
+  REAL,SAVE :: clesphy0(longcles)
+  !$OMP THREADPRIVATE(clesphy0)
   !
   ! Variables propres a la physique
@@ -291,4 +291,7 @@
   SAVE itap                   ! compteur pour la physique
   !$OMP THREADPRIVATE(itap)
+
+  INTEGER, SAVE :: abortphy=0   ! Reprere si on doit arreter en fin de phys
+  !$OMP THREADPRIVATE(abortphy)
   !
   REAL,save ::  solarlong0
@@ -636,7 +639,7 @@
   !$OMP THREADPRIVATE(fact_cldcon,facttemps)
 
-  integer iflag_cldth
-  save iflag_cldth
-  !$OMP THREADPRIVATE(iflag_cldth)
+  integer iflag_cld_th
+  save iflag_cld_th
+  !$OMP THREADPRIVATE(iflag_cld_th)
   logical ptconv(klon,klev)
   !IM cf. AM 081204 BEG
@@ -865,4 +868,7 @@
 
   REAL zzz
+!albedo SB >>>
+  real,dimension(6),save :: SFRWL
+!albedo SB <<<
 
   !======================================================================
@@ -913,5 +919,5 @@
           solarlong0,seuil_inversion, &
           fact_cldcon, facttemps,ok_newmicro,iflag_radia, &
-          iflag_cldth,iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs, &
+          iflag_cld_th,iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs, &
           ok_ade, ok_aie, ok_cdnc, aerosol_couple,  &
           flag_aerosol, flag_aerosol_strat, new_aod, &
@@ -924,4 +930,11 @@
      print*, '================================================='
      !
+!CR: check sur le nb de traceurs de l eau
+     if ((iflag_ice_thermo.gt.0).and.(nqo==2)) then
+          WRITE (lunout, *) ' iflag_ice_thermo==1 requires 3 H2O tracers (H2Ov, H2Ol, H2Oi)', ' but nqo=', nqo, &
+          '. Might as well stop here.'
+          STOP
+     endif
+
      dnwd0=0.0
      ftd=0.0
@@ -1014,6 +1027,6 @@
      print*,'CYCLE_DIURNE', cycle_diurne
      !
-     IF (iflag_con.EQ.2.AND.iflag_cldth.GT.-1) THEN
-        abort_message = 'Tiedtke needs iflag_cldth=-2 or -1'
+     IF (iflag_con.EQ.2.AND.iflag_cld_th.GT.-1) THEN
+        abort_message = 'Tiedtke needs iflag_cld_th=-2 or -1'
         CALL abort_gcm (modname,abort_message,1)
      ENDIF
@@ -1130,5 +1143,5 @@
                 ,alp_bl_prescr, ale_bl_prescr)
            ! 11/09/06 rajout initialisation ALE et ALP du wake et PBL(YU)
-           !        print*,'apres ini_wake iflag_cldth=', iflag_cldth
+           !        print*,'apres ini_wake iflag_cld_th=', iflag_cld_th
         endif
 
@@ -1342,4 +1355,26 @@
      mskocean_beta=.FALSE.
 
+!albedo SB >>>
+     select case(nsw)
+     case(2)
+     SFRWL(1)=0.45538747
+     SFRWL(2)=0.54461211
+     case(4)
+     SFRWL(1)=0.45538747
+     SFRWL(2)=0.32870591
+     SFRWL(3)=0.18568763
+     SFRWL(4)=3.02191470E-02
+     case(6)
+     SFRWL(1)=1.28432794E-03
+     SFRWL(2)=0.12304168
+     SFRWL(3)=0.33106142
+     SFRWL(4)=0.32870591
+     SFRWL(5)=0.18568763
+     SFRWL(6)=3.02191470E-02
+     end select
+
+
+!albedo SB <<<
+
      OPEN(99,file='beta_crf.data',status='old', &
           form='formatted',err=9999)
@@ -1378,6 +1413,8 @@
   !
   CALL change_srf_frac(itap, dtime, days_elapsed+1,  &
-       pctsrf, falb1, falb2, ftsol, ustar, u10m, v10m, pbl_tke)
-
+!albedo SB >>>
+!       pctsrf, falb1, falb2, ftsol, ustar, u10m, v10m, pbl_tke)
+       pctsrf, falb_dir, falb_dif, ftsol, ustar, u10m, v10m, pbl_tke)
+!albedo SB <<<
 
   ! Update time and other variables in Reprobus
@@ -1569,5 +1606,7 @@
   !IM END
   !
-  CALL hgardfou(t_seri,ftsol,'debutphy')
+  CALL hgardfou(t_seri,ftsol,'debutphy',abortphy)
+  IF (abortphy==1) Print*,'ERROR ABORT hgardfou debutphy'
+
   !
   !IM BEG
@@ -1813,7 +1852,13 @@
 !>nrlmd+jyg
           pplay,     paprs,     pctsrf,             &
-          ftsol,falb1,falb2,ustar,u10m,v10m,wstar,  &
+!albedo SB >>>
+!          ftsol,falb1,falb2,ustar,u10m,v10m,wstar,  &
+          ftsol,SFRWL,falb_dir,falb_dif,ustar,u10m,v10m,wstar, &
+!albedo SB <<<
           cdragh,    cdragm,  u1,    v1,            &
-          albsol1,   albsol2,   sens,    evap,      &
+!albedo SB >>>
+!          albsol1,   albsol2,   sens,    evap,      &
+          albsol_dir,   albsol_dif,   sens,    evap,   &  
+!albedo SB <<<
           albsol3_lic,runoff,   snowhgt,   qsnow, to_ice, sissnow, &
           zxtsol,    zxfluxlat, zt2m,    qsat2m,  &
@@ -1868,8 +1913,8 @@
      IF (klon_glo==1) THEN
         CALL add_pbl_tend &
-             (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,dqi0,paprs,'vdf')
+        (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,dqi0,paprs,'vdf',abortphy)
      ELSE
         CALL add_phys_tend &
-             (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,dqi0,paprs,'vdf')
+        (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,dqi0,paprs,'vdf',abortphy)
      ENDIF
      !--------------------------------------------------------------------
@@ -1881,4 +1926,36 @@
         call writefield_phy('q_seri',q_seri,llm)
      endif
+
+
+!albedo SB >>>
+ albsol1=0.
+ albsol2=0.
+ falb1=0.
+ falb2=0.
+select case(nsw)
+case(2)
+ albsol1=albsol_dir(:,1)
+ albsol2=albsol_dir(:,2)
+ falb1=falb_dir(:,1,:)
+ falb2=falb_dir(:,2,:)
+case(4)
+ albsol1=albsol_dir(:,1)
+ albsol2=albsol_dir(:,2)*SFRWL(2)+albsol_dir(:,3)*SFRWL(3)+albsol_dir(:,4)*SFRWL(4)
+ albsol2=albsol2/(SFRWL(2)+SFRWL(3)+SFRWL(4))
+ falb1=falb_dir(:,1,:)
+ falb2=falb_dir(:,2,:)*SFRWL(2)+falb_dir(:,3,:)*SFRWL(3)+falb_dir(:,4,:)*SFRWL(4)
+ falb2=falb2/(SFRWL(2)+SFRWL(3)+SFRWL(4))
+case(6)
+ albsol1=albsol_dir(:,1)*SFRWL(1)+albsol_dir(:,2)*SFRWL(2)+albsol_dir(:,3)*SFRWL(3)
+ albsol1=albsol1/(SFRWL(1)+SFRWL(2)+SFRWL(3))
+ albsol2=albsol_dir(:,4)*SFRWL(4)+albsol_dir(:,5)*SFRWL(5)+albsol_dir(:,6)*SFRWL(6)
+ albsol2=albsol2/(SFRWL(4)+SFRWL(5)+SFRWL(6))
+ falb1=falb_dir(:,1,:)*SFRWL(1)+falb_dir(:,2,:)*SFRWL(2)+falb_dir(:,3,:)*SFRWL(3)
+ falb1=falb1/(SFRWL(1)+SFRWL(2)+SFRWL(3))
+ falb2=falb_dir(:,4,:)*SFRWL(4)+falb_dir(:,5,:)*SFRWL(5)+falb_dir(:,6,:)*SFRWL(6)
+ falb2=falb2/(SFRWL(4)+SFRWL(5)+SFRWL(6))
+end select
+!albedo SB <<<
+
 
      CALL evappot(klon,nbsrf,ftsol,pplay(:,1),cdragh, &
@@ -2221,5 +2298,5 @@
      !   calcul des proprietes des nuages convectifs
      clwcon0(:,:)=fact_cldcon*clwcon0(:,:)
-     IF (iflag_cld_cv <= 1) THEN
+     IF (iflag_cld_cv == 0) THEN
      call clouds_gno &
           (klon,klev,q_seri,zqsat,clwcon0,ptconv,ratqsc,rnebcon0)
@@ -2273,5 +2350,6 @@
 
   CALL add_phys_tend(d_u_con, d_v_con, d_t_con, d_q_con, dql0, dqi0, paprs, &
-       'convection')
+       'convection',abortphy)
+
   !----------------------------------------------------------------------------
 
@@ -2442,5 +2520,5 @@
      d_t_wake(:,:)=dt_wake(:,:)*dtime
      d_q_wake(:,:)=dq_wake(:,:)*dtime
-     CALL add_phys_tend(du0,dv0,d_t_wake,d_q_wake,dql0,dqi0,paprs,'wake')
+     CALL add_phys_tend(du0,dv0,d_t_wake,d_q_wake,dql0,dqi0,paprs,'wake',abortphy)
      !------------------------------------------------------------------------
 
@@ -2461,5 +2539,5 @@
   END IF
 
-  !      print*,'apres callwake iflag_cldth=', iflag_cldth
+  !      print*,'apres callwake iflag_cld_th=', iflag_cld_th
   !
   !===================================================================
@@ -2753,5 +2831,5 @@
         !-----------------------------------------------------------------------
         ! ajout des tendances de l'ajustement sec ou des thermiques
-        CALL add_phys_tend(du0,dv0,d_t_ajsb,d_q_ajsb,dql0,dqi0,paprs,'ajsb')
+        CALL add_phys_tend(du0,dv0,d_t_ajsb,d_q_ajsb,dql0,dqi0,paprs,'ajsb',abortphy)
         d_t_ajs(:,:)=d_t_ajs(:,:)+d_t_ajsb(:,:)
         d_q_ajs(:,:)=d_q_ajs(:,:)+d_q_ajsb(:,:)
@@ -2782,5 +2860,5 @@
   ! water distribution
   CALL  calcratqs(klon,klev,prt_level,lunout,        &
-       iflag_ratqs,iflag_con,iflag_cldth,pdtphys,  &
+       iflag_ratqs,iflag_con,iflag_cld_th,pdtphys,  &
        ratqsbas,ratqshaut,tau_ratqs,fact_cldcon,   &
        ptconv,ptconvth,clwcon0th, rnebcon0th,     &
@@ -2804,5 +2882,5 @@
        frac_impa, frac_nucl, beta_prec_fisrt, &
        prfl, psfl, rhcl,  &
-       zqasc, fraca,ztv,zpspsk,ztla,zthl,iflag_cldth, &
+       zqasc, fraca,ztv,zpspsk,ztla,zthl,iflag_cld_th, &
        iflag_ice_thermo)
   !
@@ -2810,5 +2888,5 @@
   WHERE (snow_lsc < 0) snow_lsc = 0.
 
-  CALL add_phys_tend(du0,dv0,d_t_lsc,d_q_lsc,d_ql_lsc,d_qi_lsc,paprs,'lsc')
+  CALL add_phys_tend(du0,dv0,d_t_lsc,d_q_lsc,d_ql_lsc,d_qi_lsc,paprs,'lsc',abortphy)
   !---------------------------------------------------------------------------
   DO k = 1, klev
@@ -2860,10 +2938,10 @@
   !
   !IM cf FH
-  !     IF (iflag_cldth.eq.-1) THEN ! seulement pour Tiedtke
-  IF (iflag_cldth.le.-1) THEN ! seulement pour Tiedtke
+  !     IF (iflag_cld_th.eq.-1) THEN ! seulement pour Tiedtke
+  IF (iflag_cld_th.le.-1) THEN ! seulement pour Tiedtke
      snow_tiedtke=0.
      !     print*,'avant calcul de la pseudo precip '
-     !     print*,'iflag_cldth',iflag_cldth
-     if (iflag_cldth.eq.-1) then
+     !     print*,'iflag_cld_th',iflag_cld_th
+     if (iflag_cld_th.eq.-1) then
         rain_tiedtke=rain_con
      else
@@ -2898,5 +2976,5 @@
      ENDDO
 
-  ELSE IF (iflag_cldth.ge.3) THEN
+  ELSE IF (iflag_cld_th.ge.3) THEN
      !  On prend pour les nuages convectifs le max du calcul de la
      !  convection et du calcul du pas de temps precedent diminue d'un facteur
@@ -2954,11 +3032,12 @@
         tausum_aero(:,:,:) = 0.
         IF (iflag_rrtm .EQ. 0) THEN !--old radiation
-           tau_aero(:,:,:,:) = 0.
-           piz_aero(:,:,:,:) = 0.
+           tau_aero(:,:,:,:) = 1.e-15
+           piz_aero(:,:,:,:) = 1.
            cg_aero(:,:,:,:)  = 0.
         ELSE
-           tau_aero_sw_rrtm(:,:,:,:)=0.0
-           piz_aero_sw_rrtm(:,:,:,:)=0.0
-           cg_aero_sw_rrtm(:,:,:,:)=0.0
+           tau_aero_sw_rrtm(:,:,:,:) = 1.e-15
+           tau_aero_lw_rrtm(:,:,:,:) = 1.e-15
+           piz_aero_sw_rrtm(:,:,:,:) = 1.0
+           cg_aero_sw_rrtm(:,:,:,:)  = 0.0
         ENDIF
      ENDIF
@@ -2987,5 +3066,5 @@
      !   On prend la somme des fractions nuageuses et des contenus en eau
 
-     if (iflag_cldth>=5) then
+     if (iflag_cld_th>=5) then
 
         do k=1,klev
@@ -3293,14 +3372,26 @@
   IF (MOD(itaprad,radpas).EQ.0) THEN
 
-     DO i = 1, klon
-        albsol1(i) = falb1(i,is_oce) * pctsrf(i,is_oce) &
-             + falb1(i,is_lic) * pctsrf(i,is_lic) &
-             + falb1(i,is_ter) * pctsrf(i,is_ter) &
-             + falb1(i,is_sic) * pctsrf(i,is_sic)
-        albsol2(i) = falb2(i,is_oce) * pctsrf(i,is_oce) &
-             + falb2(i,is_lic) * pctsrf(i,is_lic) &
-             + falb2(i,is_ter) * pctsrf(i,is_ter) &
-             + falb2(i,is_sic) * pctsrf(i,is_sic)
-     ENDDO
+!albedo SB >>>  
+  if(ok_chlorophyll)then
+  print*,"-- reading chlorophyll"
+  call readchlorophyll(debut)
+  endif
+  !do i=1,klon
+  !if(chl_con(i)>1.) print*,i,chl_con(i),pctsrf(i,is_ter)
+  !enddo
+!albedo SB <<<
+
+!albedo SB >>>
+!     DO i = 1, klon
+!        albsol1(i) = falb1(i,is_oce) * pctsrf(i,is_oce) &
+!             + falb1(i,is_lic) * pctsrf(i,is_lic) &
+!             + falb1(i,is_ter) * pctsrf(i,is_ter) &
+!             + falb1(i,is_sic) * pctsrf(i,is_sic)
+!        albsol2(i) = falb2(i,is_oce) * pctsrf(i,is_oce) &
+!             + falb2(i,is_lic) * pctsrf(i,is_lic) &
+!             + falb2(i,is_ter) * pctsrf(i,is_ter) &
+!             + falb2(i,is_sic) * pctsrf(i,is_sic)
+!     ENDDO
+!albedo SB <<<
 
      if (mydebug) then
@@ -3350,5 +3441,8 @@
         CALL radlwsw &
              (dist, rmu0, fract,  &
-             paprs, pplay,zxtsol,albsol1, albsol2,  &
+!albedo SB >>>
+!             paprs, pplay,zxtsol,albsol1, albsol2,  &
+             paprs, pplay,zxtsol,SFRWL,albsol_dir, albsol_dif,  &
+!albedo SB <<<
              t_seri,q_seri,wo, &
              cldfrarad, cldemirad, cldtaurad, &
@@ -3403,5 +3497,8 @@
               CALL radlwsw &
                    (dist, rmu0, fract,  &
-                   paprs, pplay,zxtsol,albsol1, albsol2,  &
+!albedo SB >>>
+!                   paprs, pplay,zxtsol,albsol1, albsol2,  &
+                   paprs, pplay,zxtsol,SFRWL,albsol_dir, albsol_dif, & 
+!albedo SB <<<
                    t_seri,q_seri,wo, &
                    cldfra, cldemi, cldtau, &
@@ -3470,6 +3567,6 @@
   d_t_sw0(:,:)=heat0(:,:)*dtime/RDAY
   d_t_lw0(:,:)=-cool0(:,:)*dtime/RDAY
-  CALL add_phys_tend(du0,dv0,d_t_swr,dq0,dql0,dqi0,paprs,'SW')
-  CALL add_phys_tend(du0,dv0,d_t_lwr,dq0,dql0,dqi0,paprs,'LW')
+  CALL add_phys_tend(du0,dv0,d_t_swr,dq0,dql0,dqi0,paprs,'SW',abortphy)
+  CALL add_phys_tend(du0,dv0,d_t_lwr,dq0,dql0,dqi0,paprs,'LW',abortphy)
 
   !
@@ -3554,5 +3651,5 @@
      !-----------------------------------------------------------------------------------------
      ! ajout des tendances de la trainee de l'orographie
-     CALL add_phys_tend(d_u_oro,d_v_oro,d_t_oro,dq0,dql0,dqi0,paprs,'oro')
+     CALL add_phys_tend(d_u_oro,d_v_oro,d_t_oro,dq0,dql0,dqi0,paprs,'oro',abortphy)
      !-----------------------------------------------------------------------------------------
      !
@@ -3600,5 +3697,5 @@
      !-----------------------------------------------------------------------------------------
      ! ajout des tendances de la portance de l'orographie
-     CALL add_phys_tend(d_u_lif,d_v_lif,d_t_lif,dq0,dql0,dqi0,paprs,'lif')
+     CALL add_phys_tend(d_u_lif,d_v_lif,d_t_lif,dq0,dql0,dqi0,paprs,'lif',abortphy)
      !-----------------------------------------------------------------------------------------
      !
@@ -3614,5 +3711,5 @@
      !
      !  ajout des tendances
-     CALL add_phys_tend(d_u_hin,d_v_hin,d_t_hin,dq0,dql0,dqi0,paprs,'hin')
+     CALL add_phys_tend(d_u_hin,d_v_hin,d_t_hin,dq0,dql0,dqi0,paprs,'hin',abortphy)
 
   ENDIF
@@ -3623,5 +3720,5 @@
           du_gwd_rando, dv_gwd_rando)
      CALL add_phys_tend(du_gwd_rando, dv_gwd_rando, dt0, dq0, dql0,dqi0,paprs, &
-          'flott_gwd_rando')
+          'flott_gwd_rando',abortphy)
   end if
 
@@ -3677,5 +3774,5 @@
      CALL METHOX(1,klon,klon,klev,q_seri,d_q_ch4,pplay)
   ! ajout de la tendance d'humidite due au methane
-     CALL add_phys_tend(du0,dv0,dt0,d_q_ch4*dtime,dql0,'q_ch4')
+     CALL add_phys_tend(du0,dv0,dt0,d_q_ch4*dtime,dql0,'q_ch4',abortphy)
   END IF
   !
@@ -4058,5 +4155,5 @@
   !On effectue les sorties:
 
-  CALL phys_output_write(itap, pdtphys, paprs, pphis,               &
+  CALL phys_output_write(itap, pdtphys, paprs, pphis,  &
        pplay, lmax_th, aerosol_couple,                 &
        ok_ade, ok_aie, ivap, new_aod, ok_sync,         &
@@ -4067,5 +4164,4 @@
 
 
-
   include "write_histday_seri.h"
 
@@ -4073,4 +4169,16 @@
 
 #endif
+
+
+!====================================================================
+! Arret du modele apres hgardfou en cas de detection d'un
+! plantage par hgardfou
+!====================================================================
+
+    IF (abortphy==1) THEN
+       abort_message ='Plantage hgardfou'
+       CALL abort_gcm (modname,abort_message,1)
+    ENDIF
+
 
   ! 22.03.04 END
Index: LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90	(revision 2258)
@@ -10,5 +10,8 @@
 SUBROUTINE radlwsw( &
    dist, rmu0, fract, &
-   paprs, pplay,tsol,alb1, alb2, &
+!albedo SB >>>
+!  paprs, pplay,tsol,alb1, alb2, &
+   paprs, pplay,tsol,SFRWL,alb_dir, alb_dif, &
+!albedo SB <<<
    t,q,wo,&
    cldfra, cldemi, cldtaupd,&
@@ -174,5 +177,10 @@
   REAL,    INTENT(in)  :: rmu0(KLON), fract(KLON)
   REAL,    INTENT(in)  :: paprs(KLON,KLEV+1), pplay(KLON,KLEV)
-  REAL,    INTENT(in)  :: alb1(KLON), alb2(KLON), tsol(KLON)
+!albedo SB >>>
+! REAL,    INTENT(in)  :: alb1(KLON), alb2(KLON), tsol(KLON)
+  REAL,    INTENT(in)  :: tsol(KLON)
+  REAL,    INTENT(in) :: alb_dir(KLON,NSW),alb_dif(KLON,NSW)
+  real, intent(in) :: SFRWL(6)
+!albedo SB <<<
   REAL,    INTENT(in)  :: t(KLON,KLEV), q(KLON,KLEV)
 
@@ -418,18 +426,58 @@
 !     zfract(i) = 1.     !!!!!!  essai MPL 19052010
       zrmu0(i) = rmu0(iof+i)
-      PALBD(i,1) = alb1(iof+i)
-      PALBD(i,2) = alb2(iof+i)
-!
-         PALBD_NEW(i,1) = alb1(iof+i)   !!!!! A REVOIR (MPL) PALBD_NEW en fonction bdes SW
-         do kk=2,NSW
-           PALBD_NEW(i,kk) = alb2(iof+i)
-         enddo
-      PALBP(i,1) = alb1(iof+i)
-      PALBP(i,2) = alb2(iof+i)
-!
-         PALBP_NEW(i,1) = alb1(iof+i)     !!!!! A REVOIR (MPL) PALBP_NEW en fonction bdes SW
-         do kk=2,NSW
-           PALBP_NEW(i,kk) = alb2(iof+i)
-         enddo
+
+
+!albedo SB >>>
+!      PALBD(i,1) = alb1(iof+i)
+!      PALBD(i,2) = alb2(iof+i)
+!         PALBD_NEW(i,1) = alb1(iof+i)   !!!!! A REVOIR (MPL) PALBD_NEW en
+!         fonction bdes SW
+!         do kk=2,NSW
+!           PALBD_NEW(i,kk) = alb2(iof+i)
+!         enddo
+!      PALBP(i,1) = alb1(iof+i)
+!      PALBP(i,2) = alb2(iof+i)
+!
+!         PALBP_NEW(i,1) = alb1(iof+i)     !!!!! A REVOIR (MPL) PALBP_NEW en
+!         fonction bdes SW
+!         do kk=2,NSW
+!           PALBP_NEW(i,kk) = alb2(iof+i)
+!         enddo
+
+      if(iflag_rrtm==0)then
+        select case(nsw)
+        case(2)
+          PALBD(i,1)=alb_dif(iof+i,1)
+          PALBD(i,2)=alb_dif(iof+i,2)
+          PALBP(i,1)=alb_dir(iof+i,1)
+          PALBP(i,2)=alb_dir(iof+i,2)
+        case(4)
+          PALBD(i,1)=alb_dif(iof+i,1)
+          PALBD(i,2)=(alb_dif(iof+i,2)*SFRWL(2)+alb_dif(iof+i,3)*SFRWL(3) &
+                 +alb_dif(iof+i,4)*SFRWL(4))/(SFRWL(2)+SFRWL(3)+SFRWL(4))
+          PALBP(i,1)=alb_dir(iof+i,1)
+          PALBP(i,2)=(alb_dir(iof+i,2)*SFRWL(2)+alb_dir(iof+i,3)*SFRWL(3) &
+                 +alb_dir(iof+i,4)*SFRWL(4))/(SFRWL(2)+SFRWL(3)+SFRWL(4))
+        case(6)
+          PALBD(i,1)=(alb_dif(iof+i,1)*SFRWL(1)+alb_dif(iof+i,2)*SFRWL(2) &
+                 +alb_dif(iof+i,3)*SFRWL(3))/(SFRWL(1)+SFRWL(2)+SFRWL(3))
+          PALBD(i,2)=(alb_dif(iof+i,4)*SFRWL(4)+alb_dif(iof+i,5)*SFRWL(5) &
+                 +alb_dif(iof+i,6)*SFRWL(6))/(SFRWL(4)+SFRWL(5)+SFRWL(6))
+          PALBP(i,1)=(alb_dir(iof+i,1)*SFRWL(1)+alb_dir(iof+i,2)*SFRWL(2)  &
+                 +alb_dir(iof+i,3)*SFRWL(3))/(SFRWL(1)+SFRWL(2)+SFRWL(3))
+          PALBP(i,2)=(alb_dir(iof+i,4)*SFRWL(4)+alb_dir(iof+i,5)*SFRWL(5)  &
+                 +alb_dir(iof+i,6)*SFRWL(6))/(SFRWL(4)+SFRWL(5)+SFRWL(6))
+        end select
+      elseif(iflag_rrtm==1)then
+        DO kk=1,NSW
+         PALBD_NEW(i,kk)=alb_dif(iof+i,kk)
+         PALBP_NEW(i,kk)=alb_dir(iof+i,kk)
+        ENDDO
+      endif
+!albedo SB <<<
+
+
+
+
       PEMIS(i) = 1.0    !!!!! A REVOIR (MPL) 
       PVIEW(i) = 1.66
Index: LMDZ5/branches/testing/libf/phylmd/readchlorophyll.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/readchlorophyll.F90	(revision 2258)
+++ LMDZ5/branches/testing/libf/phylmd/readchlorophyll.F90	(revision 2258)
@@ -0,0 +1,131 @@
+!
+! $Id$
+!
+
+subroutine readchlorophyll(debut)
+
+    use netcdf95, only: nf95_close, nf95_gw_var, nf95_inq_dimid, & 
+                        nf95_inq_varid, nf95_open
+    use netcdf, only: nf90_get_var, nf90_noerr, nf90_nowrite
+
+    USE phys_cal_mod, ONLY : mth_cur
+    USE mod_grid_phy_lmdz
+    USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
+    USE mod_phys_lmdz_para 
+    USE phys_state_var_mod
+    USE phys_local_var_mod
+    USE dimphy
+
+    implicit none
+
+    include "YOMCST.h"
+    include "dimensions.h"
+
+! Variable input
+    logical debut
+
+! Variables locales
+    integer n_lat   ! number of latitudes in the input data
+    integer n_lon   ! number of longitudes in the input data
+    integer n_lev   ! number of levels in the input data
+    integer n_month ! number of months in the input data
+    real, pointer:: latitude(:)
+    real, pointer:: longitude(:)
+    real, pointer:: time(:)
+    integer i, k
+    integer, save :: mth_pre
+!$OMP THREADPRIVATE(mth_pre)
+
+! Champs reconstitues
+    real, allocatable:: chlorocon(:, :, :)
+    real, allocatable:: chlorocon_mois(:, :)
+    real, allocatable:: chlorocon_mois_glo(:)
+
+! For NetCDF:
+    integer ncid_in  ! IDs for input files
+    integer varid, ncerr
+
+
+!--------------------------------------------------------
+
+
+!--only read file if beginning of run or start of new month
+    IF (debut.OR.mth_cur.NE.mth_pre) THEN
+
+    IF (is_mpi_root) THEN
+
+
+    CALL nf95_open("chlorophyll.nc", nf90_nowrite, ncid_in)
+
+    CALL nf95_inq_varid(ncid_in, "lon", varid)
+    CALL nf95_gw_var(ncid_in, varid, longitude)
+    n_lon = size(longitude)
+!    print *, 'LON chlorophyll=', n_lon, longitude
+    IF (n_lon.NE.iim) THEN
+       print *,'Le nombre de lon n est pas egal a iim'
+       STOP
+    ENDIF
+
+
+    CALL nf95_inq_varid(ncid_in, "lat", varid)
+    CALL nf95_gw_var(ncid_in, varid, latitude)
+    n_lat = size(latitude)
+!    print *, 'LAT chlorophyll=', n_lat, latitude
+    IF (n_lat.NE.jjm+1) THEN 
+       print *,'Le nombre de lat n est pas egal a jjm+1'
+       STOP
+    ENDIF
+
+    CALL nf95_inq_varid(ncid_in, "time", varid)
+    CALL nf95_gw_var(ncid_in, varid, time)
+    n_month = size(time)
+!    print *, 'TIME aerosol strato=', n_month, time
+    IF (n_month.NE.12) THEN 
+       print *,'Le nombre de month n est pas egal a 12'
+       STOP
+    ENDIF
+
+    IF (.not.ALLOCATED(chlorocon))          ALLOCATE(chlorocon(n_lon, n_lat, n_month))
+    IF (.not.ALLOCATED(chlorocon_mois))     ALLOCATE(chlorocon_mois(n_lon, n_lat))
+    IF (.not.ALLOCATED(chlorocon_mois_glo)) ALLOCATE(chlorocon_mois_glo(klon_glo))
+
+!--reading stratospheric AOD at 550 nm
+    CALL nf95_inq_varid(ncid_in, "CHL", varid)
+    ncerr = nf90_get_var(ncid_in, varid, chlorocon)
+    print *,'code erreur readaerosolstrato=', ncerr, varid
+
+    CALL nf95_close(ncid_in)
+
+!---select the correct month
+    IF (mth_cur.LT.1.OR.mth_cur.GT.12) THEN
+      print *,'probleme avec le mois dans readaerosolstrat =', mth_cur
+    ENDIF
+    chlorocon_mois(:,:) = chlorocon(:,:,mth_cur)
+
+!---reduce to a klon_glo grid 
+    CALL grid2dTo1d_glo(chlorocon_mois,chlorocon_mois_glo)
+
+
+    print*,"chrolophyll current month",mth_cur
+    do i=1,klon_glo
+      if(isnan(chlorocon_mois_glo(i)))then
+         chlorocon_mois_glo(i)=0.
+      endif
+      !print*,"high chl con",i,chlorocon_mois_glo(i)
+    enddo
+
+!    DEALLOCATE(chlorocon)
+!    DEALLOCATE(chlorocon_mois)
+!    DEALLOCATE(chlorocon_mois_glo)
+  
+    ENDIF !--is_mpi_root
+
+!--scatter on all proc
+    CALL scatter(chlorocon_mois_glo,chl_con)
+
+!--keep memory of previous month
+    mth_pre=mth_cur
+
+    ENDIF !--debut ou nouveau mois
+
+end subroutine readchlorophyll
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90	(revision 2258)
@@ -473,5 +473,5 @@
                                tau_ae(i,k,id_ASSSM_phy,inu)+tau_ae(i,k,id_CSSSM_phy,inu)+   &
                                tau_ae(i,k,id_SSSSM_phy,inu)+ tau_ae(i,k,id_CIDUSTM_phy,inu)
-         tau_allaer(i,k,2,inu)=MAX(tau_allaer(i,k,2,inu),1e-5)
+         tau_allaer(i,k,2,inu)=MAX(tau_allaer(i,k,2,inu),1e-15)
 
          piz_allaer(i,k,2,inu)=(tau_ae(i,k,id_ASSO4M_phy,inu)*piz_ae(i,k,id_ASSO4M_phy,inu)+ &
@@ -486,5 +486,5 @@
                                 tau_ae(i,k,id_CIDUSTM_phy,inu)*piz_ae(i,k,id_CIDUSTM_phy,inu)) &
                                 /tau_allaer(i,k,2,inu)
-         piz_allaer(i,k,2,inu)=MAX(piz_allaer(i,k,2,inu),0.1)
+         piz_allaer(i,k,2,inu)=MAX(piz_allaer(i,k,2,inu),0.01)
 
          cg_allaer(i,k,2,inu)=(tau_ae(i,k,id_ASSO4M_phy,inu)*piz_ae(i,k,id_ASSO4M_phy,inu)*cg_ae(i,k,id_ASSO4M_phy,inu)+ &
@@ -506,5 +506,5 @@
                                tau_ae_pi(i,k,id_ASSSM_phy,inu)+tau_ae_pi(i,k,id_CSSSM_phy,inu)+   &
                                tau_ae_pi(i,k,id_SSSSM_phy,inu)+ tau_ae_pi(i,k,id_CIDUSTM_phy,inu)
-         tau_allaer(i,k,1,inu)=MAX(tau_allaer(i,k,1,inu),1e-5)
+         tau_allaer(i,k,1,inu)=MAX(tau_allaer(i,k,1,inu),1e-15)
 
          piz_allaer(i,k,1,inu)=(tau_ae_pi(i,k,id_ASSO4M_phy,inu)*piz_ae(i,k,id_ASSO4M_phy,inu)+ &
@@ -519,5 +519,5 @@
                                 tau_ae_pi(i,k,id_CIDUSTM_phy,inu)*piz_ae(i,k,id_CIDUSTM_phy,inu)) &
                                 /tau_allaer(i,k,1,inu)
-         piz_allaer(i,k,1,inu)=MAX(piz_allaer(i,k,1,inu),0.1)
+         piz_allaer(i,k,1,inu)=MAX(piz_allaer(i,k,1,inu),0.01)
 
          cg_allaer(i,k,1,inu)=(tau_ae_pi(i,k,id_ASSO4M_phy,inu)*piz_ae(i,k,id_ASSO4M_phy,inu)*cg_ae(i,k,id_ASSO4M_phy,inu)+ &
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_lw_rrtm.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_lw_rrtm.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_lw_rrtm.F90	(revision 2258)
@@ -9,5 +9,5 @@
   IMPLICIT NONE
 
-  tau_aero_lw_rrtm(:,:,:,:)=0.0
+  tau_aero_lw_rrtm(:,:,:,:) = 1.e-15
 
 END SUBROUTINE AEROPT_LW_RRTM
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/readaerosolstrato_rrtm.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/readaerosolstrato_rrtm.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/readaerosolstrato_rrtm.F90	(revision 2258)
@@ -211,3 +211,15 @@
     ENDDO
 
+!--default SSA value if there is no aerosol
+!--to avoid 0 values that seems to cause some problem to RRTM
+    WHERE (tau_aero_sw_rrtm.LT.1.e-14)
+      piz_aero_sw_rrtm = 1.0
+    ENDWHERE
+
+!--in principle this should not be necessary 
+!--as these variables have min values already but just in case
+!--put 1e-15 min value to both SW and LW AOD
+    tau_aero_sw_rrtm = MAX(tau_aero_sw_rrtm,1.e-15)
+    tau_aero_lw_rrtm = MAX(tau_aero_lw_rrtm,1.e-15)
+
 end subroutine readaerosolstrato_rrtm
Index: LMDZ5/branches/testing/libf/phylmd/screenc.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/screenc.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/screenc.F90	(revision 2258)
@@ -66,11 +66,15 @@
 ! Richardson at reference level 
 !
-      CALL coefcdrag (klon, knon, nsrf, zxli, &
+!      CALL coefcdrag (klon, knon, nsrf, zxli, &
+!                    speed, temp, q_zref, gref, &
+!                    psol, ts, qsurf, rugos, &
+!                    okri, ri1, &
+!                    cdram, cdrah, cdran, zri1, &
+!                    pref)
+! Fuxing WANG, 04/03/2015, replace the coefcdrag by the merged version: cdrag
+      CALL cdrag (knon, nsrf, &
                     speed, temp, q_zref, gref, &
                     psol, ts, qsurf, rugos, &
-                    okri, ri1, &
-                    cdram, cdrah, cdran, zri1, &
-                    pref)
-!
+                    cdram, cdrah, zri1, pref)
       DO i = 1, knon
         delu(i) = ustar(i)/sqrt(cdram(i))
Index: LMDZ5/branches/testing/libf/phylmd/stdlevvar.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/stdlevvar.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/stdlevvar.F90	(revision 2258)
@@ -98,8 +98,14 @@
 !
       okri=.FALSE.
-      CALL coefcdrag(klon, knon, nsrf, zxli, &
- &                   speed, t1, q1, z1, psol, &
- &                   ts1, qsurf, rugos, okri, ri1,  &         
- &                   cdram, cdrah, cdran, zri1, pref)            
+!      CALL coefcdrag(klon, knon, nsrf, zxli, &
+! &                   speed, t1, q1, z1, psol, &
+! &                   ts1, qsurf, rugos, okri, ri1,  &         
+! &                   cdram, cdrah, cdran, zri1, pref)            
+! Fuxing WANG, 04/03/2015, replace the coefcdrag by the merged version: cdrag
+      CALL cdrag(knon, nsrf, &
+ &                   speed, t1, q1, z1, &
+ &                   psol, ts1, qsurf, rugos, &
+ &                   cdram, cdrah, zri1, pref)
+
 ! --- special Dice: on force cdragm ( a defaut de forcer ustar) MPL 05082013
      IF (ok_prescr_ust) then
Index: LMDZ5/branches/testing/libf/phylmd/surf_land_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/surf_land_mod.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/surf_land_mod.F90	(revision 2258)
@@ -17,5 +17,8 @@
        lwdown_m, q2m, t2m, &
        snow, qsol, agesno, tsoil, &
-       z0_new, alb1_new, alb2_new, evap, fluxsens, fluxlat, &
+!albedo SB >>>
+!      z0_new, alb1_new, alb2_new, evap, fluxsens, fluxlat, &
+       z0_new, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, &   
+!albedo SB <<<
        qsurf, tsurf_new, dflux_s, dflux_l, &
        flux_u1, flux_v1 ) 
@@ -35,4 +38,7 @@
     INCLUDE "dimsoil.h"
     INCLUDE "YOMCST.h"
+!albedo SB >>>
+    INCLUDE "clesphys.h"
+!albedo SB <<<
 
 ! Input variables  
@@ -71,6 +77,10 @@
 !****************************************************************************************
     REAL, DIMENSION(klon), INTENT(OUT)       :: z0_new
-    REAL, DIMENSION(klon), INTENT(OUT)       :: alb1_new ! albdeo for shortwave interval 1(visible)
-    REAL, DIMENSION(klon), INTENT(OUT)       :: alb2_new ! albedo for shortwave interval 2(near infrared)
+!albedo SB >>>
+!    REAL, DIMENSION(klon), INTENT(OUT)       :: alb1_new ! albdeo for shortwave interval 1(visible)
+!    REAL, DIMENSION(klon), INTENT(OUT)       :: alb2_new ! albedo for shortwave interval 2(near infrared)
+    REAL, DIMENSION(6), INTENT(IN) :: SFRWL
+    REAL, DIMENSION(klon,nsw), INTENT(OUT)       :: alb_dir_new,alb_dif_new
+!albedo SB <<<
     REAL, DIMENSION(klon), INTENT(OUT)       :: evap
     REAL, DIMENSION(klon), INTENT(OUT)       :: fluxsens, fluxlat
@@ -89,4 +99,8 @@
     REAL, DIMENSION(klon) :: u0, v0     ! surface speed
     INTEGER               :: i
+
+!albedo SB >>>
+    REAL, DIMENSION(klon)      :: alb1_new,alb2_new
+!albedo SB <<<
 
 
@@ -165,4 +179,29 @@
          p1lay, temp_air, &
          flux_u1, flux_v1)
+
+!albedo SB >>>
+
+
+     select case(NSW)
+     case(2)
+       alb_dir_new(1:knon,1)=alb1_new(1:knon)
+       alb_dir_new(1:knon,2)=alb2_new(1:knon)
+     case(4)
+       alb_dir_new(1:knon,1)=alb1_new(1:knon)
+       alb_dir_new(1:knon,2)=alb2_new(1:knon)
+       alb_dir_new(1:knon,3)=alb2_new(1:knon)
+       alb_dir_new(1:knon,4)=alb2_new(1:knon)
+     case(6)
+       alb_dir_new(1:knon,1)=alb1_new(1:knon)
+       alb_dir_new(1:knon,2)=alb1_new(1:knon)
+       alb_dir_new(1:knon,3)=alb1_new(1:knon)
+       alb_dir_new(1:knon,4)=alb2_new(1:knon)
+       alb_dir_new(1:knon,5)=alb2_new(1:knon)
+       alb_dir_new(1:knon,6)=alb2_new(1:knon)
+     end select
+alb_dif_new=alb_dir_new
+!albedo SB <<<
+
+
     
   END SUBROUTINE surf_land
